summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDave Reisner <dreisner@archlinux.org>2012-02-16 04:50:51 +0100
committerDan McGee <dan@archlinux.org>2012-02-17 00:31:16 +0100
commitca4142714137b16feabac09c4cda86b0a75036f8 (patch)
tree76706d41581a2f764ba9c51f4d5ae151bcedae6a
parent242006933d31c88b844f8f8d0c2f0806763cc51f (diff)
downloadpacman-ca4142714137b16feabac09c4cda86b0a75036f8.tar.gz
pacman-ca4142714137b16feabac09c4cda86b0a75036f8.tar.xz
parseopts: normalize options into an array
Modify parse_options logic to fill an array instead of printing parsed options. Avoid eval like the plague. Because it is the plague. Fixes bugs such as FS#28445. Signed-off-by: Dave Reisner <dreisner@archlinux.org> Signed-off-by: Dan McGee <dan@archlinux.org>
-rw-r--r--scripts/library/parse_options.sh32
-rw-r--r--scripts/makepkg.sh.in6
-rw-r--r--scripts/pacman-key.sh.in6
3 files changed, 17 insertions, 27 deletions
diff --git a/scripts/library/parse_options.sh b/scripts/library/parse_options.sh
index 48fd42cd..39038de6 100644
--- a/scripts/library/parse_options.sh
+++ b/scripts/library/parse_options.sh
@@ -23,17 +23,15 @@ parse_options() {
[[ ${match} = ${1:2}:: && -n $2 && ${2:0:1} != "-" ]] && needsargument=1
if (( ! needsargument )); then
- printf ' %s' "$1"
+ OPTRET+=("$1")
else
if [[ -n $2 ]]; then
- printf ' %s ' "$1"
+ OPTRET+=("$1" "$2")
shift
- printf "'%q" "$1"
while [[ -n $2 && ${2:0:1} != "-" ]]; do
shift
- printf " %q" "$1"
+ OPTRET+=("$1")
done
- printf "'"
else
printf "@SCRIPTNAME@: $(gettext "option %s requires an argument\n")" "'$1'" >&2
ret=1
@@ -57,26 +55,22 @@ parse_options() {
( -n ${1:$i+1} || ( -n $2 && ${2:0:1} != "-" ) ) ]] && needsargument=1
if (( ! needsargument )); then
- printf ' -%s' "${1:i:1}"
+ OPTRET+=("-${1:i:1}")
else
if [[ -n ${1:$i+1} ]]; then
- printf ' -%s ' "${1:i:1}"
- printf "'%q" "${1:$i+1}"
+ OPTRET+=("-${1:i:1}" "${1:i+1}")
while [[ -n $2 && ${2:0:1} != "-" ]]; do
shift
- printf " %q" "$1"
+ OPTRET+=("$1")
done
- printf "'"
else
if [[ -n $2 ]]; then
- printf ' -%s ' "${1:i:1}"
+ OPTRET+=("-${1:i:1}" "$2")
shift
- printf "'%q" "$1"
while [[ -n $2 && ${2:0:1} != "-" ]]; do
shift
- printf " %q" "$1"
+ OPTRET+=("$1")
done
- printf "'"
else
printf "@SCRIPTNAME@: $(gettext "option %s requires an argument\n")" "'-${1:i:1}'" >&2
@@ -91,15 +85,11 @@ parse_options() {
fi
done
else
- unused_options="${unused_options} '$1'"
+ unused_options+=("$1")
fi
shift
done
- printf " --"
- [[ $unused_options ]] && printf ' %s' "${unused_options[@]}"
- [[ $1 ]] && printf " '%s'" "$@"
- printf "\n"
-
+ OPTRET+=('--' "${unused_options[@]}")
return $ret
-} \ No newline at end of file
+}
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index 9766c8c6..805c31a9 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -1906,11 +1906,11 @@ OPT_LONG+=",version,config:"
# Pacman Options
OPT_LONG+=",noconfirm,noprogressbar"
-if ! OPT_TEMP="$(parse_options $OPT_SHORT $OPT_LONG "$@")"; then
+if ! parse_options $OPT_SHORT $OPT_LONG "$@"; then
echo; usage; exit 1 # E_INVALID_OPTION;
fi
-eval set -- "$OPT_TEMP"
-unset OPT_SHORT OPT_LONG OPT_TEMP
+set -- "${OPTRET[@]}"
+unset OPT_SHORT OPT_LONG OPTRET
while true; do
case "$1" in
diff --git a/scripts/pacman-key.sh.in b/scripts/pacman-key.sh.in
index 45ece51b..4b678041 100644
--- a/scripts/pacman-key.sh.in
+++ b/scripts/pacman-key.sh.in
@@ -504,11 +504,11 @@ OPT_LONG="add::,config:,delete:,edit-key:,export::,finger::,gpgdir:"
OPT_LONG+=",help,import:,import-trustdb:,init,keyserver:,list-keys::,list-sigs::"
OPT_LONG+=",lsign-key:,populate::,recv-keys:,refresh-keys::,updatedb"
OPT_LONG+=",verify:,version"
-if ! OPT_TEMP="$(parse_options $OPT_SHORT $OPT_LONG "$@")"; then
+if ! parse_options $OPT_SHORT $OPT_LONG "$@"; then
echo; usage; exit 1 # E_INVALID_OPTION;
fi
-eval set -- "$OPT_TEMP"
-unset OPT_SHORT OPT_LONG OPT_TEMP
+set -- "${OPTRET[@]}"
+unset OPT_SHORT OPT_LONG OPTRET
if [[ $1 == "--" ]]; then
usage;